#pragma once

// 16K=16384
#define HUGELEN     0x4000
// 4K=4096
#define BUFLEN      0x1000
// 1K=1024
#define DOCLEN		0x400
// 256
#define TEXTLEN     0x100
#define HALFVALUE	0x18
#define HEXNUMBER   0x10
#define MINFILESIZE 4

#define WM_MYCHANGE   (WM_APP + 1)
#define WM_MYCLOSE    (WM_APP + 2)
#define WM_MYBORDER   (WM_APP + 3)
#define WM_MYREPLACE  (WM_APP + 4)
#define WM_MYRESIZE   (WM_APP + 5)

// BYTE: unsigned char
#define uchar unsigned char
// WORD: unsigned short int
#define uint unsigned int
#define ushort unsigned short
// DWORD: unsigned long
#define ulong unsigned long

#ifdef CONSOLE
#define SUCCESS 0
#define FAILER  1
#endif

#define CAST(TYPE, PARM) ((TYPE)(PARM))
#define SIZECHECK(SIZE) (0xc0000000 & (SIZE))

// 0xFF 0xFE: byte order mark of UTF-16
#define BOMCODE L'\xFEFF'
#define BOMSTR L"\xFEFF"
// type of bitmap
#define BITMAPTYPE 0x4d42

#define BINARYTEXTSIZE 9
#define STATUSBARHEIGHT 18

#define ICONSIZE 128

typedef union
{
    struct
	{
		ulong ulLow;
		ulong ulHigh;
	} strQuadWord;
	uchar auchQuadWordAry[2 * sizeof(DWORD)];
} QUADWORD;

#define ERRORSTATE       -1
#define ALLDLGHIDE       0x000
#define SCANNERDLGSHOW   0x010
#define CHANGEDLGSHOW    0x020
#define PICTUREDLGSHOW   0x040
#define LISTDLGSHOW      0x080
#define TRANSFORMDLGSHOW 0x100
#define SEQUENCEDLGSHOW  0x200
#define DIFFERENCEDLGSHOW  0x400

//typedef struct tagBITMAPINFO {
//@@BITMAPINFOHEADER bmiHeader;
//@@RGBQUAD bmiColors[1];
// } BITMAPINFO;

typedef enum
{
    ALLFILEMODE,
	ARCHIVEONLYMODE,
    ARCHIVEEXCLUSIVEMODE,
	FOLDERMODE
} SELECTIONMODE;

typedef enum
{
    NOOPTIONMODE,
	ATTRIBUTESMODE,
	FILESIZEMODE,
	BOTHOPTIONMODE
} OPTIONMODE;

typedef struct
{
	BOOL bSubFolder;
	SELECTIONMODE enmSelectionMode;
	OPTIONMODE enmOptionMode;
} LISTPACK;

#define TABCNT4 4
#define TABCNT8 8

typedef enum
{
	DISPLAYMODE,
	SEARCHMODE,
	LISTMODE
} ISDISPLAYMODE;

typedef enum
{
	TWOLINEMODE,
	ONELINEMODE,
	EXCLUSIVEMODE
} ISCONTAINMODE;

typedef enum
{
    RIGHTROTATEMODE,
    UPENDROTATEMODE,
    LEFTROTATEMODE,
	CONVERTMODE
} ROTATEMODE;

typedef enum
{
    NOBLOCKMODE,
    READYBLOCKMODE,
    STARTBLOCKMODE,
    ENDBLOCKMODE,
} BLOCKMODE;

typedef enum
{
	SCANNERDLGTYPE,
	CHANGEDLGTYPE
}DIALOGTYPE;

// puchBitmapImagePtr ͕\ĂҏW̃C[W
// puchBitmapBufPtr + nHeaderSize ͓ǂݍ܂ꂽҏWÕC[W
typedef struct
{
	HBITMAP hBitmap;
	uchar*  puchBitmapImagePtr;
	uchar*  puchBitmapBufPtr;
} BITMAPPACK;

#define PENWIDTH 2
typedef struct
{
	int nSrcPosX;
	int nSrcPosY;
	int nSrcWidth;
	int nSrcHeight;
	int nDstPosX;
	int nDstPosY;
	int nDstWidth;
	int nDstHeight;
} BITCOPYPACK;

// https://learn.microsoft.com/ja-jp/windows/win32/api/gdiplustypes/ne-gdiplustypes-status
typedef enum {
	Ok = 0,
	GenericError = 1,
	InvalidParameter = 2,
	OutOfMemory = 3,
	ObjectBusy = 4,
	InsufficientBuffer = 5,
	NotImplemented = 6,
	Win32Error = 7,
	WrongState = 8,
	Aborted = 9,
	FileNotFound = 10,
	ValueOverflow = 11,
	AccessDenied = 12,
	UnknownImageFormat = 13,
	FontFamilyNotFound = 14,
	FontStyleNotFound = 15,
	NotTrueTypeFont = 16,
	UnsupportedGdiplusVersion = 17,
	GdiplusNotInitialized = 18,
	PropertyNotFound = 19,
	PropertyNotSupported = 20,
	ProfileNotFound = 21
}STATUS;

// \̂̃o[Ȃ
typedef struct tagICONDIR {
	WORD    idReserved;         //\ς݁iɂOj
	WORD    idType;             //\[X^Cv@ACRF1AJ[\FQ
	WORD    idCount;            //ACR̐
}ICONFILEHEADER;

typedef struct tagICONDIRENTRY {
	BYTE    bWidth;         //摜iPʁFsNZj
	BYTE    bHeight;        //摜iPʁFsNZj
	BYTE    bColorCount;    //摜̐FiQTUFȏ͂Oj
	BYTE    bReserved;	    //\ς݁iɂOj
	WORD    wPlanes;        //J[v[@@iJ[\AwzbgX|bgj
	WORD    wBitCount;      //sNZ̃rbg[xiJ[\AxzbgX|bgj
	DWORD   dwBytesInRes;   //sNZf[^̃oCg
	DWORD   dwImageOffset;  //t@C擪sNZf[^܂ł̃ItZbg
}ICONINFOHEADER;

typedef enum {
	NOTYPE,
	PICTURETYPE,
	TEXTTYPE
} DRAWTYPE;



